<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubsidiarySearchRow StructType
 * @subpackage Structs
 */
class SubsidiarySearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchRowBasic
     */
    public $basic;
    /**
     * The addressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchRowBasic
     */
    public $addressJoin;
    /**
     * The defaultAdvanceToApplyAccountJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AccountSearchRowBasic
     */
    public $defaultAdvanceToApplyAccountJoin;
    /**
     * The returnAddressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchRowBasic
     */
    public $returnAddressJoin;
    /**
     * The shippingAddressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchRowBasic
     */
    public $shippingAddressJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for SubsidiarySearchRow
     * @uses SubsidiarySearchRow::setBasic()
     * @uses SubsidiarySearchRow::setAddressJoin()
     * @uses SubsidiarySearchRow::setDefaultAdvanceToApplyAccountJoin()
     * @uses SubsidiarySearchRow::setReturnAddressJoin()
     * @uses SubsidiarySearchRow::setShippingAddressJoin()
     * @uses SubsidiarySearchRow::setUserJoin()
     * @uses SubsidiarySearchRow::setCustomSearchJoin()
     * @param \StructType\SubsidiarySearchRowBasic $basic
     * @param \StructType\AddressSearchRowBasic $addressJoin
     * @param \StructType\AccountSearchRowBasic $defaultAdvanceToApplyAccountJoin
     * @param \StructType\AddressSearchRowBasic $returnAddressJoin
     * @param \StructType\AddressSearchRowBasic $shippingAddressJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\SubsidiarySearchRowBasic $basic = null, \StructType\AddressSearchRowBasic $addressJoin = null, \StructType\AccountSearchRowBasic $defaultAdvanceToApplyAccountJoin = null, \StructType\AddressSearchRowBasic $returnAddressJoin = null, \StructType\AddressSearchRowBasic $shippingAddressJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAddressJoin($addressJoin)
            ->setDefaultAdvanceToApplyAccountJoin($defaultAdvanceToApplyAccountJoin)
            ->setReturnAddressJoin($returnAddressJoin)
            ->setShippingAddressJoin($shippingAddressJoin)
            ->setUserJoin($userJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\SubsidiarySearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\SubsidiarySearchRowBasic $basic
     * @return \StructType\SubsidiarySearchRow
     */
    public function setBasic(\StructType\SubsidiarySearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get addressJoin value
     * @return \StructType\AddressSearchRowBasic|null
     */
    public function getAddressJoin()
    {
        return $this->addressJoin;
    }
    /**
     * Set addressJoin value
     * @param \StructType\AddressSearchRowBasic $addressJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setAddressJoin(\StructType\AddressSearchRowBasic $addressJoin = null)
    {
        $this->addressJoin = $addressJoin;
        return $this;
    }
    /**
     * Get defaultAdvanceToApplyAccountJoin value
     * @return \StructType\AccountSearchRowBasic|null
     */
    public function getDefaultAdvanceToApplyAccountJoin()
    {
        return $this->defaultAdvanceToApplyAccountJoin;
    }
    /**
     * Set defaultAdvanceToApplyAccountJoin value
     * @param \StructType\AccountSearchRowBasic $defaultAdvanceToApplyAccountJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setDefaultAdvanceToApplyAccountJoin(\StructType\AccountSearchRowBasic $defaultAdvanceToApplyAccountJoin = null)
    {
        $this->defaultAdvanceToApplyAccountJoin = $defaultAdvanceToApplyAccountJoin;
        return $this;
    }
    /**
     * Get returnAddressJoin value
     * @return \StructType\AddressSearchRowBasic|null
     */
    public function getReturnAddressJoin()
    {
        return $this->returnAddressJoin;
    }
    /**
     * Set returnAddressJoin value
     * @param \StructType\AddressSearchRowBasic $returnAddressJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setReturnAddressJoin(\StructType\AddressSearchRowBasic $returnAddressJoin = null)
    {
        $this->returnAddressJoin = $returnAddressJoin;
        return $this;
    }
    /**
     * Get shippingAddressJoin value
     * @return \StructType\AddressSearchRowBasic|null
     */
    public function getShippingAddressJoin()
    {
        return $this->shippingAddressJoin;
    }
    /**
     * Set shippingAddressJoin value
     * @param \StructType\AddressSearchRowBasic $shippingAddressJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setShippingAddressJoin(\StructType\AddressSearchRowBasic $shippingAddressJoin = null)
    {
        $this->shippingAddressJoin = $shippingAddressJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subsidiarySearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$subsidiarySearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($subsidiarySearchRowCustomSearchJoinItem) ? get_class($subsidiarySearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($subsidiarySearchRowCustomSearchJoinItem), var_export($subsidiarySearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\SubsidiarySearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\SubsidiarySearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
